c===========================================================
c     tsrand: Driver routine illustrating use of srand()
c     to "seed" the random number generator, rand(), 
c     available on the SGIs.
c
c     Given seed >= 0 and, optionally, number of deviates to 
c     generate, outputs
c
c       <i>   <random number>
c
c     i = 1 ... number of deviates on standard output.
c===========================================================
      program         tsrand

      implicit        none

c-----------------------------------------------------------
c     Uniform (on [0.0 .. 1.0]) random number generator.
c-----------------------------------------------------------
      real*8          rand                

      integer         iargc,        i4arg

c-----------------------------------------------------------
c     Command-line arguments:
c
c     seed:     Integer-valued argument to srand() which 
c               seeds the rand() random number generator.
c     n:        Number of deviates to generate
c-----------------------------------------------------------
      integer         seed,         n,
     &                              default_n
      parameter     (               default_n = 1 000 )

      integer         i

      if( iargc() .lt. 1 ) go to 900

      seed = i4arg(1,-1)
      if( seed .lt. 0 ) go to 900
      n    = i4arg(2,default_n)

      call srand(seed)
      do i = 1 , n
         write(*,*) i, rand()
      end do

      stop

 900  continue
         write(0,*) 'usage: tsrand <seed> [<n deviates>]'
      stop

      end
